<?php

namespace EventPortal\Domain\Admin\Handlers;

use Closure;
use EventPortal\Domain\Admin\Models\Admin;
use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\User\Events\UserCreated;

class CreateAdmin
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $admin = Admin::create($payload->getInput());

        $admin->user_id = $payload->getModel()->id;
        $admin->save();

        Delegate::create(['user_id' => $admin->user_id]);

        event(new UserCreated($payload->getModel()));

        $payload->addContext('admin', $admin);

        return $next($payload);
    }
}
